/* =========================================================================

NAME: ScriptBoxSuite 1.5

AUTHOR: banIDit (bondura@list.ru)
DATE  : 12.09.2007 10:00

COMMENT:
1. Create bookmarks for each page in the document and "subbookmarks" with information about boxes.
2. Show information about page boxes of current page.
3. Separate active document by pages.

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
app.addMenuItem ({cName: "SBS_&BookmarkBox", cParent: "Tools", cExec: "BM_pages()", bPrepend: true, nPos: 0});
app.addMenuItem ({cName: "SBS_&ShowMeBoxes", cParent: "Tools", cExec: "ShowMeBoxes()", bPrepend: true, nPos: 1});
app.addMenuItem ({cName: "SBS_ToPageSe&parator", cParent: "Tools", cExec: "extract_pages()", bPrepend: true, nPos: 2});

function extract_pages()
{
var myDoc = event.target;
var myDocName = myDoc.path;
var filename = myDocName.replace(".pdf","");
	try 
	{
		for (var i = 0; i < myDoc.numPages; i++) 
		{
			myDocExtract = myDoc.extractPages({nStart: i});
		 	myDocExtract.saveAs({cPath: filename+"_" + (i+1) +".pdf"});
			myDocExtract.closeDoc(true);
		}
	}
catch(e)
{
app.alert("Processing error: "+e)
}
}

function BM_pages() //  
{
var myDoc = event.target;
var myDocs = app.activeDocs;
		if (myDocs.length > 0)
		{

if (myDoc.bookmarkRoot.children != null)
{
	if (myDoc.bookmarkRoot.children[0].name == "BookmarkBox")
	{
		myDoc.bookmarkRoot.children[0].remove ()
	};
};


myDoc.bookmarkRoot.createChild("BookmarkBox", "this.bookmarkRoot.children[0].remove();", 0);
var root = myDoc.bookmarkRoot.children[0]; 

try {
	for (var i = 0; i < myDoc.numPages; i++)
       {	
		var pLabel = myDoc.getPageLabel (i); 
		root.createChild("Page " + pLabel, "this.pageNum=" + i, i);
			var width = BoxWidth("Media",i); 
			var height = BoxHeight("Media",i);			
		root.children[i].createChild("MediaBox: " + width + " x " + height, "this.pageNum=" + i, 0);
		root.children[i].children[0].color = ["RGB",1,0,1];
		root.children[i].children[0].createChild("LL [" + CornCord("Media",i,0)+";"+CornCord("Media",i,3)+"]"+", "+"UR ["+CornCord("Media",i,2)+";"+CornCord("Media",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[0].open = false;	
			var width = BoxWidth("Crop",i); 
			var height = BoxHeight("Crop",i);
		root.children[i].createChild("CropBox: " + width + " x " + height, "this.pageNum=" + i, 1);
		root.children[i].children[1].color = ["RGB",0,0,0];
		root.children[i].children[1].createChild("LL [" + CornCord("Crop",i,0)+";"+CornCord("Crop",i,3)+"]"+", "+"UR ["+CornCord("Crop",i,2)+";"+CornCord("Crop",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[1].open = false;
			var width = BoxWidth("Trim",i); 
			var height = BoxHeight("Trim",i);
		root.children[i].createChild("TrimBox: " + width + " x " + height, "this.pageNum=" + i, 2);
		root.children[i].children[2].color = ["RGB",0,0.5,0];
		root.children[i].children[2].createChild("LL [" + CornCord("Trim",i,0)+";"+CornCord("Trim",i,3)+"]"+", "+"UR ["+CornCord("Trim",i,2)+";"+CornCord("Trim",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[2].open = false;
			var width = BoxWidth("Bleed",i); 
			var height = BoxHeight("Bleed",i);
		root.children[i].createChild("BleedBox: "  + width + " x " + height, "this.pageNum=" + i, 3);
		root.children[i].children[3].color = ["RGB",0,0,1];
		root.children[i].children[3].createChild("LL [" + CornCord("Bleed",i,0)+";"+CornCord("Bleed",i,3)+"]"+", "+"UR ["+CornCord("Bleed",i,2)+";"+CornCord("Bleed",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[3].open = false;
			var width = BoxWidth("Art",i); 
			var height = BoxHeight("Art",i);
		root.children[i].createChild("ArtBox: " + width + " x " + height, "this.pageNum=" + i, 4);
		root.children[i].children[4].color = ["RGB",1,0,0];
		root.children[i].children[4].createChild("LL [" + CornCord("Art",i,0)+";"+CornCord("Art",i,3)+"]"+", "+"UR ["+CornCord("Art",i,2)+";"+CornCord("Art",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[4].open = false;
			var width = BoxWidth("BBox",i); 
			var height = BoxHeight("BBox",i);
		root.children[i].createChild("BoundingBox: " + width + " x " + height, "this.pageNum=" + i, 5);
		root.children[i].children[5].createChild("LL [" + CornCord("BBox",i,0)+";"+CornCord("BBox",i,3)+"]"+", "+"UR ["+CornCord("BBox",i,2)+";"+CornCord("BBox",i,1)+"]","this.pageNum="+i,0);
		root.children[i].children[5].open = false;
		root.children[i].open = false;
		}
		root.children[myDoc.pageNum].open = true;
		app.execMenuItem("ShowHideThumbnails");
		app.execMenuItem("ShowHideBookmarks");
	}	
catch(e)
	{
		app.alert("Processing error: "+e);
	}
}
		}

function ShowMeBoxes() 
{
var myDocs = app.activeDocs;
		if (myDocs.length > 0)
		{
try
	{ 
		var MediaWidth = BoxWidth("Media", this.pageNum);
		var MediaHeight = BoxHeight ("Media", this.pageNum);		
		var CropWidth = BoxWidth("Crop",this.pageNum);
		var CropHeight = BoxHeight("Crop",this.pageNum);
		var BleedWidth = BoxWidth("Bleed",this.pageNum);
		var BleedHeight = BoxHeight("Bleed",this.pageNum);
		var ArtWidth = BoxWidth("Art",this.pageNum);
		var ArtHeight = BoxHeight("Art",this.pageNum);
		var TrimWidth = BoxWidth("Trim",this.pageNum);
		var TrimHeight = BoxHeight("Trim",this.pageNum);
		var BBoxWidth = BoxWidth("BBox",this.pageNum);
		var BBoxHeight = BoxHeight("BBox",this.pageNum);
		
		var boxAlertBut = app.alert 
		({
			cMsg: "MediaBox: " + MediaWidth + " x " + MediaHeight + " mm\n" + 
			"CropBox: " + CropWidth + " x " + CropHeight + 
			" mm\nTrimBox: " + TrimWidth + " x " + TrimHeight + 
			" mm\nBleedBox: " + BleedWidth + " x " + BleedHeight + 
			" mm\nArtBox: " + ArtWidth + " x " + ArtHeight + 
			" mm\nBoundingBox: " + BBoxWidth + " x " + BBoxHeight + 
			" mm\n\nShow LL and UR corners of boxes?",   
			nIcon:3,
			nType:2,
			cTitle:"Page "+(this.pageNum+1)
		});
			if ( boxAlertBut == 4 ){
			app.alert ({
				cMsg: "MediaBox: LL [" + CornCord("Media",this.pageNum,0)+";"+CornCord("Media",this.pageNum,3)+"]"+", "+"UR ["+CornCord("Media",this.pageNum,2)+";"+CornCord("Media",this.pageNum,1)+"]\n"+
				"CropBox: LL [" + CornCord("Crop",this.pageNum,0)+";"+CornCord("Crop",this.pageNum,3)+"]"+", "+"UR ["+CornCord("Crop",this.pageNum,2)+";"+CornCord("Crop",this.pageNum,1)+"]\n"+
				"TrimBox: LL [" + CornCord("Trim",this.pageNum,0)+";"+CornCord("Trim",this.pageNum,3)+"]"+", "+"UR ["+CornCord("Trim",this.pageNum,2)+";"+CornCord("Trim",this.pageNum,1)+"]\n"+
				"BleedBox: LL [" + CornCord("Bleed",this.pageNum,0)+";"+CornCord("Bleed",this.pageNum,3)+"]"+", "+"UR ["+CornCord("Bleed",this.pageNum,2)+";"+CornCord("Bleed",this.pageNum,1)+"]\n"+
				"ArtBox: LL [" + CornCord("Art",this.pageNum,0)+";"+CornCord("Art",this.pageNum,3)+"]"+", "+"UR ["+CornCord("Art",this.pageNum,2)+";"+CornCord("Art",this.pageNum,1)+"]\n"+
				"BoundingBox: LL [" + CornCord("BBox",this.pageNum,0)+";"+CornCord("BBox",this.pageNum,3)+"]"+", "+"UR ["+CornCord("BBox",this.pageNum,2)+";"+CornCord("BBox",this.pageNum,1)+"]",
				nIcon:3,
				nType:0,
				cTitle:"Page "+(this.pageNum+1)+". LL and UR corners."
				});
			}
	}
catch(e)
	{
		app.alert("Processing error: "+e)
	}
}	
}	


//   #####            #####
BoxWidth = function(myBox,myPage){
	var myDoc = event.target;
	var aRect = myDoc.getPageBox(myBox,myPage);
		width = (aRect[2] - aRect[0])*0.35275;
		width = Math.decRound(width,1);
		return width;
	}

//   #####            #####
BoxHeight = function(myBox,myPage){
	var myDoc = event.target;
	var aRect = myDoc.getPageBox(myBox,myPage);
		height = (aRect[1] - aRect[3])*0.35275;
		height = Math.decRound(height,1);
		return height;
	}
//   #####             #####	
CornCord = function(myBox, myPage, IndexCorn){
	var myDoc = event.target;
	var aRect = myDoc.getPageBox(myBox,myPage);
		Corn = aRect[IndexCorn]*0.35275;
		Corn = Math.decRound(Corn,1);
		return Corn;
	}
//   #####     ,     ;)     #####
Math.decRound = function (myNum, myDecNum) {
     return Math.round (myNum * Math.pow(10, myDecNum) ) / Math.pow(10, myDecNum);
    }



